/*

  Copyright (c) 1998, 1999, Digital Creations, Fredericksburg, VA, USA.  
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:
  
    o Redistributions of source code must retain the above copyright
      notice, this list of conditions, and the disclaimer that follows.
  
    o Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions, and the following disclaimer in
      the documentation and/or other materials provided with the
      distribution.
  
    o Neither the name of Digital Creations nor the names of its
      contributors may be used to endorse or promote products derived
      from this software without specific prior written permission.
  
  
  THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS AND CONTRIBUTORS *AS
  IS* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL
  CREATIONS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
  TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
  DAMAGE.

  $Id: Buffer.i,v 1.2 1999/01/14 17:30:46 jim Exp $

  If you have questions regarding this software,
  contact:
 
    Digital Creations L.C.  
    info@digicool.com
 
    (540) 371-6909

*/

/* Typemaps for buffers */

%typemap(python, in) void *BUFFER {
  if($source->ob_type==BufferType)
    $target=(void*)(((Buffer*)$source)->val.c);
  else
    {
      PyErr_SetString(PyExc_TypeError, "buffer expected");
      return NULL;
    }
}

%typemap(python, in) void *BUFFER_OR_WHATEVER {
  if($source==Py_None) $target=NULL;
  else if($source->ob_type==BufferType)
    $target=(void*)(((Buffer*)$source)->val.c);
  else if(PyString_Check($source))
    $target=(void*)(((PyStringObject*)$source)->ob_sval);
  else if(PyFloat_Check($source))
    $target=(void*)&(PyFloat_AS_DOUBLE((PyFloatObject*)$source));
  else if(PyInt_Check($source))
    $target=(void*)&(PyInt_AS_LONG((PyIntObject*)$source));
  else
    {
      PyErr_SetString(PyExc_TypeError, "buffer expected");
      return NULL;
    }
}

%typemap(python, in) void *BUFFER_OR_NULL {
  if($source==Py_None) $target=NULL;
  else if($source->ob_type==BufferType)
    $target=(void*)(((Buffer*)$source)->val.c);
  else
    {
      PyErr_SetString(PyExc_TypeError, "buffer expected");
      return NULL;
    }
}

%typemap(python, in) void *SIZED_BUFFER (int buffer__length) {
  if($source->ob_type!=BufferType)
    {
      PyErr_SetString(PyExc_TypeError, "buffer expected");
      return NULL;
    }
  buffer__length=((Buffer*)$source)->ob_size;
  $target=(void*)(((Buffer*)$source)->val.c);
}

%typemap(python, ignore) int BUFFER_SIZE { $target=buffer__length; }

%init %{
  ImportBufferType;
%}
